/*
 * kgraft_patch_bsc1069708
 *
 * Fix for CVE-2017-16939, bsc#1069708
 *
 *  Upstream commit:
 *  1137b5e2529a ("ipsec: Fix aborted xfrm policy dump crash")
 *
 *  SLE12(-SP1) commit:
 *  9814546baade5f6e4db138eb7505cbd94908d579
 *
 *  SLE12-SP2 commit:
 *  a19419eb44bf05f2df2dc30f092e69e21468350d
 *  ce2739015acd0c27be0df3f652176dd61c72c102
 *
 *  SLE12-SP3 commit:
 *  72e3847b4ff994530b4f77b99dae1a1d03840e7d
 *  5103b61679be9d7417c38c28e43441de835c70e4
 *
 *  Copyright (c) 2017 SUSE
 *  Author: Nicolai Stange <nstange@suse.de>
 *
 *  Based on the original Linux kernel code. Other copyrights apply.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#include <linux/kernel.h>
#include <net/xfrm.h>
#include "kgr_patch_bsc1069708.h"

#if !IS_ENABLED(CONFIG_XFRM) || IS_MODULE(CONFIG_XFRM)
#error "KGR patch supports only CONFIG_XFRM=y."
#endif

#if !IS_MODULE(CONFIG_XFRM_USER)
#error "KGR patch supports only CONFIG_XFRM_USER=m."
#endif


/* patched */
int kgr_xfrm_dump_policy_done(struct netlink_callback *cb)
{
	struct xfrm_policy_walk *walk = (struct xfrm_policy_walk *) &cb->args[1];
	struct net *net = sock_net(cb->skb->sk);

	/*
	 * Fix CVE-2017-16939
	 *  -1 line, +2 lines
	 */
	if (cb->args[0])
		xfrm_policy_walk_done(walk, net);
	return 0;
}
